#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include <string.h>
#include <mem.h>

typedef unsigned int  uint;
typedef unsigned char uchar;
typedef unsigned long ulong;

extern FILE *in, *out;
void Set16Palette( void );
void SetPalette( void );
void SetUniPalette( void );
void SetEGApalette(void);
void vgamode(int mode);
void set_proc(int bpp);
void set_vmode_and_pal(int bpp);
void modify_palette(void);
extern void (*pointx)(int x, int y, int color); // 㪠⥫  㭪 ᮢ.窨
int decoder(int);

int filenum=0;

typedef struct
{
   char s[6];  // GIF87a
   int x,y;
   uchar cmap;    //  M  #bits  0 pixel bits
                  //  
   uchar back;    // background color
   uchar zero;
} GIFH;

typedef struct
{
   uchar r,g,b;
} RGB;            // a part of colormap

int split=0, // ࠧ ஢ GIF  ⤥ ࠦ
    clean=0, // १ ਨ  
    debug=0; // ᮮ饭   ࠣ

uchar gmask=0xFF; // ᪠  ࠧ冷  GIF

#define SEPARATOR 0x2C
#define TERMINATOR 0x3B
#define EXTENSION 0x21

typedef struct   // image descriptor
{
   char sep;
   int left, top, width, height;
   uchar lmap;   // local colormap, interlaced, bpp etc.
} IMG;

typedef struct   // extension control
{
   uchar intro, label, size;
   uchar flags;  // dispose method | user input | transparent
   uint delayt;  // delay time
   uchar tcolor; // transparent color
   uchar term;
} EXTC;

typedef struct   // extension remark (comment)
{
   uchar intro, label, size;
} EXTREM;

typedef struct   // extension application
{
   uchar intro, label, size;
   uchar app_id[8], authentic[3];
} EXTAPP;

typedef struct   // extension plain text
{
   uchar intro, label, size;
} EXTPT;

typedef struct   // extension unknown
{
   uchar intro, label, size;
} EXTU;

int get_byte(void)
{
   return fgetc(in);
}

int peek_byte(void)
{
   int c=fgetc(in);
   ungetc( c, in );
   if (c==EOF) { vgamode(3); printf(" 稫\n"); exit(1); }
   return c;
}


int bad_code_count=0;

   // 䫠 ᯮ짮 ﭨ 訡  EGA 
extern   int dither, EGA;
uint ColorGIFditherEGA(int icolor);

int y_pos=0;
int out_line(uchar *img, int len)
{
    int x;
    if ( dither && EGA )
        for (x=0; x<len; x++) pointx( x, y_pos, ColorGIFditherEGA( *img++ ));
    else
        for (x=0; x<len; x++) pointx( x, y_pos, *img++ );
    y_pos++;
    return 0;
}

IMG img;
EXTC extc;
EXTU extu;
EXTREM extrem;
EXTAPP extapp;

uchar pal1[256*3];
extern uchar palette[256*3];

GIFH gifh;



char local_name[80];

void OpenNext( void )
{
   if (!clean) sprintf( local_name, "z%02uz.gif", filenum++ );
   else local_name[ strlen( local_name )-1 ]='t';
   if (( out=fopen( local_name, "wb" ))==NULL)
   {
      printf("Output error\n");
      exit(1);
   }
}

int vmode_set=0; // ਧ,  ० 㦥 ⠭
void main_gif( char *argv )
{
   int i,x,y,colr;
   uchar sep, type;
   long cur_pos, t;
   long img_start, img_end;
   uint key;

   strcpy( local_name, argv );
   if ( split )
   {
      OpenNext();
   }
  begin:
   fread( &gifh, 1, sizeof(gifh), in );
   if ( split ) fwrite( &gifh, 1, sizeof(gifh), out );

   if (debug)
   printf("%c%c%c%c%c%c\nx=%u y=%u, cmap=0x%02X, back=0x%02X, zero=%u\n",
   gifh.s[0], gifh.s[1], gifh.s[2], gifh.s[3], gifh.s[4], gifh.s[5],
   gifh.x, gifh.y, gifh.cmap, gifh.back, gifh.zero );

   if ( gifh.cmap & 0x80 )
   {
      colr = 3*(1 << ((gifh.cmap & 7)+1));
      fread( palette, 1, colr, in );
      memcpy( pal1, palette, sizeof(palette));
      if ( clean ) for ( x=0; x< colr; x++ ) pal1[x] &= gmask;
      if (split) fwrite( pal1, 1, colr, out );

      if ( debug ) printf("palette\n");
      for ( x=0; x< colr; x++ )
      {
	if ( debug )
	{
	   printf("%02X ", *(((uchar *)(palette))+x));
        }
        *(((uchar *)(palette))+x) >>= 2; //  ᮢ⨬  VGA
      }
      if ( debug ) printf("\n");
   }
 next:
   sep = peek_byte(); // ⠥ ᥯
   cur_pos = ftell(in);
   if ( debug )
   {
      printf("Separator %02X '%c' at %lX\n",
      sep, sep, cur_pos );
   }
   if ( sep==SEPARATOR ) goto image;
   if ( sep==TERMINATOR )
   {
      // ᫨  ⫠ ०,  ⪠    ࢠ ࠡ
      if ( !debug && !clean && !split && !bioskey(1) )
      {	fseek( in, 0, 0); goto begin; }
      else goto done;
   }
   if ( sep==EXTENSION )
   {
      fgetc(in);
      type=fgetc(in); //   ७ ଠ ᯮ짮
      fseek( in, -2, 1 );
      switch ( type )
      {
	case 0xF9: // Graphics control
          fread( &extc, 1, sizeof(extc), in );
          if (clean) fwrite( &extc, 1, sizeof(extc), out );
          goto next;
	case 0xFE: // remark (comment) control
          fread( &extrem, 1, sizeof(extrem), in );
	  a:
          while ( extrem.size-- )
          {
             fgetc(in);
          }
	  if (( extrem.size=get_byte()) != 0 ) goto a;
          goto next;
        case 0xFF: // application extension
          fread( &extapp, 1, sizeof(extapp), in );
          //  ⪥ ࠭塞 ਧ LOOP  NetScape
          if (clean)
          if ( !memcmp( extapp.app_id, "NETSCAPE", 8 ))
          {
             fwrite( &extapp, 1, sizeof(extapp), out );
	     bw:
             extapp.size=get_byte(); fputc( extapp.size, out );
             if (extapp.size)
             { while ( extapp.size-- ) fputc( fgetc(in), out); goto bw; }
	     goto next;
          }
	  b:
          if (( extapp.size=get_byte()) != 0 )
          { while ( extapp.size-- ) fgetc(in); goto b; }
          goto next;
        default:
          fread( &extu, 1, sizeof(extu), in );
	  printf("Unknown extension block: %02X %02X %02X\n",
                  extu.intro, extu.label, extu.size );
          break;
      }
   }


  image:
   cur_pos = ftell(in);
   fread( &img, 1, sizeof(img), in );
   if (split) fwrite( &img, 1, sizeof(img), out );

   if (debug)
   printf("%8lX: IMG sep=%02X left=%u top=%u width=%u height=%u lmap=0x%02X\n",
   cur_pos,
   img.sep, img.left, img.top, img.width, img.height, img.lmap );

   if ( img.lmap & 0x80 )
   {
      colr = 3*(1 << ((img.lmap & 7)+1));
      fread( palette, 1, colr, in );
      if ( clean ) for ( x=0; x< colr; x++ ) palette[x] &= gmask;
      if (split) fwrite( palette, 1, colr, in );
      for ( x=0; x<256*3; x++ )
      {
        *(((uchar *)(palette))+x) >>= 2;
      }
      vmode_set=0; // ॡ ⠭ ०
   }

   if (debug) if (( bioskey(0) & 0xFF )==27 ) goto skip;

   if ((gifh.cmap & 7)<4)
   {
       set_proc(4);
       if (!vmode_set) set_vmode_and_pal(4);
       vmode_set=1;
   }
   else
   {
       set_proc(8);
       if (!vmode_set) set_vmode_and_pal(8);
       vmode_set=1;
   }
   if (dither)
   { (EGA) ? SetEGApalette() : SetUniPalette(); }

   y_pos=0;
   img_start=ftell(in);
   if (decoder( img.width )) { vgamode(3); printf("Decoder fails.\n");
				  exit(1); }

   if ( peek_byte()==0 ) fgetc(in); // ய⨬ 㫥   
   img_end=ftell(in);

   // ᤥ    ࠬ  3/18 ᥪ㭤
   t= *((long far *)0x46CL)+3;
   while ( *((long far *)0x46CL) < t );

   if ( split )
   {
      fseek( in, img_start, 0 );
      while ( img_start++ != img_end ) fputc( fgetc(in), out);
      if ( !clean )
      {
         fputc( TERMINATOR, out );
         fclose( out );
         OpenNext();
         fwrite( &gifh, 1, sizeof(gifh), out );
         if ( gifh.cmap & 0x80 )
         {
            fwrite( pal1, 1, 3*(1 << ((gifh.cmap & 7)+1)), out );
         }
      }
   }
   if (bioskey(1)) { goto done; }
   goto next;
 //  sep= get_byte();
 //  if (bioskey(1));
  done:
   if (clean) fputc( TERMINATOR, out );
  skip:
   key=bioskey(0);
   if (key==0x1970)  // 'p' palette
   {
      modify_palette(); fseek( in, 0, 0); goto begin;
   }
   if (split) fclose( out );
   fclose(in);
   vgamode(3);
}
