#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <dos.h>
#include <bios.h>
#include <dir.h>
#include <ctype.h>
#include <conio.h>

// compile in Compact only !

typedef  unsigned int uint;
typedef  unsigned long ulong;
typedef  unsigned char uchar;

// -------------------------------- files handling ------------------
   FILE *in, *out, *bmpOut;     // streams
        char *cur;              // pointer to a picture bitmap string
        char *buffer;           // pointer to copy buffer
        char *vid;

    long len;           // DOS image size

// -------------------------------- VESA handling -------------------
   uint isVESA=0;
   struct
   {
      char sign[4]; int ver; char far *oem;
      ulong flags; int far *modes; char reserved[512];
   } VesaInfo;

   int vesa_modes=0;  // ⮢  㯭 VESA-०

   uint granul=0;
   uint page_mask=0xFFFF;
   uint page_shift=0; // ⨯ int ⮡  㧨  cx
   uint maxX=640;
   uint maxY=480;

// ॠ쭠 "⭠"  VGA
   uchar palette[256*3];
   // 䫠 ᯮ짮 ﭨ 訡  EGA 
   int dither=0, EGA=0;
   uchar quick=1; //   

// -------------------------------- .TGA file type ------------------

struct
{
   uchar skip, colormap_type, image_type;
   uint colormap_begin, colormap_len; uchar colormap_flags;
   uint zero1, zero2; // offset's from left top of screen
   uint xsize, ysize;
   uchar bpp, flags; // bits per pixel & flags
} TGA;

struct
{
   uchar r,g,b;
} RGB;

//  RLE-஢ 祭 梥  
union
{
   struct { uchar r,g,b; } RGBvalue;
   struct { uchar r,g,b,alfa; } RGBAvalue;
} p;

   ulong in_len, totalCompRead=0;

// -------------------------------- .PCX file type ------------------

    ulong file_len;
    uchar c;

    typedef struct
    {
        char manuf, hard, encod, bitpx;
        int  x1, y1, x2, y2;
        int  hres, vres;
        char clrma[48];
        char vmode, nplanes;
        int  bplin;
        int  palinfo;
        int  shres;
        int  svres;
        char xtra[54];
    } pcxhd;

    pcxhd pcx_hdr;
    char far *in_s;
    char far *out_s;

    unsigned long pict;
    unsigned char c;
    char *get;
    char *put;
    char *from;
    char *to;
    uint i,j, x, y, count;

// -------------------------------- .SCN file type ------------------
   struct
   {
     char sign[8];
     uint x,y;
   } scn_hdr;

// -------------------------------- .BMP file type ------------------
   #define bi_RGB      0
   #define bi_RLE8     1
   #define bi_RLE4     2

struct { // BitMapFileHeader
   char      bfType[2];        //  ᨬ 'BM'
   long      bfSize;           //  䠩
   short     bfReserved1;
   short     bfReserved2;
   long      bfOffBits;        // ﭨ  砫 䠩  ᥫ

   long      biSize;           //  ⪠ , 40./12. 
} bm_hdr;


struct { // bitmapCoreHeader, size=12
   short    biWidth;          // ਭ  ᥫ
   short    biHeight;         //   ᥫ
   short    biPlanes;       // ⢮ ᫮
   short    biBitCount;     // 梥: - ⮢  ᥫ
} h12;

struct { // BitMapInfoHeader ⮫쪮 ᫨ biSize == 40.
   long      biWidth;          // ਭ  ᥫ
   long      biHeight;         //   ᥫ
   short       biPlanes;       // ⢮ ᫮
   short       biBitCount;     // 梥: - ⮢  ᥫ
   long     biCompression;
   long     biSizeImage;
   long     biXPelsPerMeter;
   long     biYPelsPerMeter;
   long     biClrUsed;
   long     biClrImportant;
} h40;

    typedef struct {
       uchar blue,green,red,reserved;
    } RGBQUAD;

    typedef struct {
        uchar blue,green,red;
    } RGBTRIPLE;

int key; //  
char copyname[128];

//  vesa_modes
int get_vesa_info(void)
{
   int i;
   asm { push ds; pop es; lea di,VesaInfo; mov ax,4F00h
        push bp; int 10h; pop bp };
        if ( _AX!=0x004F ) return 0;
   i=0;
   while ( VesaInfo.modes[i] != -1 )
   {
      if ( VesaInfo.modes[i] == 0x101 ) vesa_modes |= 1; // 640x480x256
      if ( VesaInfo.modes[i] == 0x110 ) vesa_modes |= 2; // 640x480x15bit
      if ( VesaInfo.modes[i] == 0x111 ) vesa_modes |= 4; // 640x480x16bit
      i++;
   }
   if ( EGA ) vesa_modes=0;
   if ( vesa_modes ) return 1; else return 0;
}

// ஢ 㯭 VESA-०   granularity
int query_vesa_mode( int mode )
{
   asm {     push ds; pop es; lea di,VesaInfo; mov ax,4F01h;
        mov cx,mode; push bp; int 10h; pop bp;
    cmp ax,4Fh
    jne no_v
    mov ax,word ptr es:[di+4]; mov granul,ax; or ax,ax
    je no_v
    cmp ax,64
    ja no_v
   }
   return 1;
   no_v:
   return 0;
}


void vesamode(int mode)
{
   asm { mov ax,4F02h; mov bx,mode; push bp; int 10h; pop bp; }
}

void vgamode(int mode)
{
   asm { mov ax,mode; and ax,0xFF; push bp; int 10h; pop bp; }
}

unsigned long flen( FILE *f )
{
    unsigned long len;
    fseek( f, 0, 2); len=ftell(f); fseek( f, 0, 0);
    return len;
}

void SetPalette( void )
{
   asm { push bp; mov dx,offset [palette]; push ds; pop es
         mov ax,1012h; mov cx,256; mov bx,0; int 10h; pop bp }
}

void SetUniPalette( void )
{
   int n, r, g, b;
   for ( r=0; r<8; r++ )
   {
           for ( g=0; g<8; g++ )
           {
                   for ( b=0; b<4; b++ )
                   {
                        n=b+g*4+r*32;
                        palette[n*3+0]=9*r;
                        palette[n*3+1]=9*g;
                        palette[n*3+2]=21*b;
                   }
           }
   }
   SetPalette();
}

uchar EGApalette[]={ 0, 0, 0,
  0,0,42,
  0,42,0,
  0,42,42,
  42,0,0,
  42,0,42,
  42,21,0,
  42,42,42,
  21,21,21,
  21,21,63,
  21,63,21,
  21,63,63,
  63,21,21,
  63,21,63,
  63,63,21,
  63,63,63 };

uchar EGAindex[]={ 0 , 0 , 4 , 12 , 0 , 0 , 4 , 12 ,
                   2 , 2 , 2 , 14 , 10 , 10 , 10 , 14 ,
                   8 , 8 , 4 , 12 , 8 , 8 , 4 , 12 ,
                   2 , 2 , 10 , 14 , 10 , 10 , 10 , 14 ,
                   1 , 1 , 5 , 13 , 1 , 1 , 5 , 13 ,
                   3 , 3 , 7 , 13 , 11 , 11 , 11 , 15 ,
                   9 , 9 , 9 , 13 , 9 , 9 , 9 , 13 ,
                   11 , 11 , 11 , 13 , 11 , 11 , 11 , 15 };

void SetEGApalette(void)
{
  memcpy( palette, EGApalette, 16*3 );
  vgamode(0x12);
        asm { mov     dx, 3CEh
              mov     ax, 0205h
              out     dx, ax };  // ०  2
}

uint x_red, x_green, x_blue; //  祭 ⮢ 梥⮢
 int e_red=0, e_green=0, e_blue=0; // ।騥 訡 ⮢ 梥⮢
uint rgb, color ;   //  15-⭮ ஢

 //  ᯮ ⠪  Color5dither() 

void Color5ditherEGA(void)
{
   int  r,g,b,r1,g1,b1;
   //   祭 ( 冷 梥⮢  ᫮ BGR )
   //     
   x_red   = ((rgb >> 10) & 0x01F)<<1;
   x_green = ((rgb >> 5) & 0x01F)<<1;
   x_blue  = (rgb & 0x01F)<<1;
   // ⥬ 訡 ।饩 窨
   // ०   2   red, 2 green, 2 blue

   e_red += x_red;
   e_green += x_green;
   e_blue  += x_blue;

   if (e_red<0) e_red=0;
   if (e_green<0) e_green=0;
   if (e_blue<0) e_blue=0;

   r = (e_red) >>4;    r += (e_red & 8) > 0;
   g = (e_green) >>4;  g += (e_green & 8) > 0;
   b = (e_blue) >>4;   b += (e_blue & 8) > 0;

   r1=0; g1=0; b1=0;
   if (r>3) { r=3; r1=1; }
   if (g>3) { g=3; g1=1; }
   if (b>3) { b=3; b1=1; }

   color=EGAindex[r+g*4+b*16];
   e_red   -= ((r1) ? e_red : palette[color*3+0]);
   e_green -= ((g1) ? e_green : palette[color*3+1]);
   e_blue  -= ((b1) ? e_blue :palette[color*3+2]);

}


extern uchar pal1[256*3]; //  , ⠭  .GIF
// ᯮ    .GIF   .EGA
//  室 -  梥  
uint ColorGIFditherEGA(int icolor)
{
   int  r,g,b,r1,g1,b1;
   //   祭 ( 冷 梥⮢  ᫮ BGR )
   //     
   x_red   = pal1[icolor*3] >> 2;
   x_green = pal1[icolor*3+1] >> 2;
   x_blue  = pal1[icolor*3+2] >> 2;
   // ⥬ 訡 ।饩 窨
   // ०   2   red, 2 green, 2 blue

   e_red += x_red;
   e_green += x_green;
   e_blue  += x_blue;

   if (e_red<0) e_red=0;
   if (e_green<0) e_green=0;
   if (e_blue<0) e_blue=0;

   r = (e_red) >>4;    r += (e_red & 8) > 0;
   g = (e_green) >>4;  g += (e_green & 8) > 0;
   b = (e_blue) >>4;   b += (e_blue & 8) > 0;

   r1=0; g1=0; b1=0;
   if (r>3) { r=3; r1=1; }
   if (g>3) { g=3; g1=1; }
   if (b>3) { b=3; b1=1; }

   color=EGAindex[r+g*4+b*16];
   e_red   -= ((r1) ? e_red : palette[color*3+0]);
   e_green -= ((g1) ? e_green : palette[color*3+1]);
   e_blue  -= ((b1) ? e_blue :palette[color*3+2]);

   return color;
}


void Set16Palette( void )
{
  asm { push si; push di; lea di,palette; mov bx,15; add di,1Eh }
label1:
  asm  mov     dh,[bx+di]
  asm  mov     ch,[bx+di+1]
  asm  mov     cl,[bx+di+2]
  asm  push    bx
  asm  mov     ax,1007h
  //       get palette reg bl into bh
  asm  push    bp
  asm  int     10h
  asm  pop     bp

  asm  mov     bl,bh
  asm  xor     bh,bh
  asm  mov     ax,1010h
  //      set color reg bx with colors
  asm  push    bp
  //      dh=red, ch=green, cl=blue
  asm  int     10h
  asm  pop     bp

  asm  pop     bx
  asm  sub     di,2
  asm  dec     bx
  asm  jns     label1
  asm  pop di
  asm  pop si
  ;
}

char bc; // 稪 ⮢  梥⮢  祬 8 /ᥫ
int (*get_color)(void); // 㪠⥫  㭪  梥 । 窨
void (*pointx)(int x, int y, int color); // 㪠⥫  㭪 ᮢ.窨

char color1(void)
{
    char tmp;
    if (bc>8) { bc -= 8; cur++; };
    tmp= *cur;
    bc++;
    return (( tmp << (bc-2)) & 0x80)? 1:0;
}

char color4(void)
{
    char tmp;
    if (bc>8) { bc -= 8; cur++; };
    tmp= *cur;
    bc += 4;
    tmp = (( tmp << (bc-5)) & 0xF0);
    tmp >>= 4;
    return tmp;
}

char color8(void)
{
    return *cur++;
}

char color24(void)
{
    char tmp;
    tmp= ((*cur++)>>6); // blue
    tmp += ((*cur++)>>5)*32 ; // red
    tmp += ((*cur++)>>5)*4; // green
    return tmp;
}

int color24_16(void)
{
    int  tmp;
    tmp= ((*cur++)>>3); // blue
    tmp += ((*cur++)>>2)<<5 ; // red
    tmp += ((*cur++)>>3)<<11; // green
    return tmp;
}

int color24_15(void)
{
    int  tmp;
    tmp= ((*cur++)>>3); // blue
    tmp += ((*cur++)>>3)<<10 ; // red
    tmp += ((*cur++)>>3)<<5; // green
    return tmp;
}


// DIB 16 bit routines
int color16_16(void)            // convert 5:5:5 DIB -> 5:6:5 rgb
{
    int  tmp;
    tmp= *((short *)cur);
    cur += 2;
    return (tmp & 0x1F) + ((tmp << 1) & ( ~ 0x3F));
}

int color16_15(void)
{
    int  tmp;
    tmp= *((short *)cur);
    cur += 2;
    return (tmp);
}

// -------------------------------- point() functions ------------------
   uint last_page=0xFF;
void point1(int x, int y, int color)
{
        if (( x>maxX ) || ( y>maxY )) return;

        asm pusha;
        asm mov al,byte ptr [color];
        asm mov cx,[x];
        asm mov dx,[y];
        asm push    ax
        asm mov     ax,0A000h
        asm mov     es,ax
        asm mov     ax,dx
        asm mov     bx,80
        asm mul     bx
        asm mov     bx,ax
        asm mov     ax,cx
        asm mov     cx,8
	asm div     cx
        asm add     bx,ax
        asm mov     cx,dx
	asm mov     ax,8008h
        asm shr     ah,cl
        asm mov     dx, 3CEh
        asm out     dx,ax
        asm mov     al, es:[bx]
        asm pop     ax
        asm mov     es:[bx],al
        asm popa;
}

void point8(int x, int y, int color)
{
        if (( x>maxX ) || ( y>maxY )) return;

            asm mov ax,maxX
            asm mov cx,y
            asm mul cx
            asm add ax,x
            asm mov bx,ax
        asm mov ax,0A000h
        asm mov es,ax
        asm mov al,byte ptr [color]
        asm mov es:[bx],al
        ;
}

void point8vesa(int x, int y, int color)
{
        if (( x>maxX ) || ( y>maxY )) return;

            asm { push bp; mov ax,640; mov cx,y; mul cx
                add ax,x
                adc dx,0
                mov bx,ax
                and bx,word ptr [page_mask]
                mov cx,word ptr [page_shift]
                jcxz no_shift }
            sh:
            asm shl ax,1
            asm rcl dx,1
            asm loop sh
            no_shift:
            asm push bx
            asm cmp dx,last_page
            asm je  mk_point
            asm mov last_page,dx
            asm mov ax,4F05h
            asm xor bx,bx
            asm int 10h
        mk_point:
            asm pop bx
            asm pop bp
        asm mov ax,0A000h
        asm mov es,ax
        asm mov al,byte ptr [color]
        asm mov es:[bx],al
        return;
}

void point24(int x, int y, int color)
{
        if (( x>maxX ) || ( y>maxY )) return;

        asm { push bp; mov ax,640*2; mov cx,y; mul cx
            add ax,x
            adc dx,0
            add ax,x
            adc dx,0
            mov bx,ax
            and bx,word ptr [page_mask]
            mov cx,word ptr [page_shift]
            jcxz no_shiftx }
        shx:
        asm shl ax,1
        asm rcl dx,1
        asm loop shx
        no_shiftx:
        asm push bx
        asm cmp dx,last_page
        asm je  mk_pointx
        asm mov last_page,dx
        asm mov ax,4F05h
        asm xor bx,bx
        asm int 10h
    mk_pointx:
        asm pop bx
        asm pop bp
           asm mov ax,0A000h
           asm mov es,ax
           asm mov ax, [color]
           asm mov es:[bx],ax
}

void point(int x, int y, int color)
{
        if (( x>maxX ) || ( y>maxY )) return;

        if (( get_color==color24_15 ) || ( get_color==color24_16 ))
        {
               asm { push bp; mov ax,640*2; mov cx,y; mul cx
                   add ax,x
                   adc dx,0
		   add ax,x
		   adc dx,0
		   mov bx,ax
                   and bx,word ptr [page_mask]
                   mov cx,word ptr [page_shift]
                   jcxz no_shiftx }
               shx:
               asm shl ax,1
               asm rcl dx,1
               asm loop shx
               no_shiftx:
               asm push bx
               asm cmp dx,last_page
               asm je  mk_pointx
	       asm mov last_page,dx
	       asm mov ax,4F05h
	       asm xor bx,bx
	       asm int 10h
           mk_pointx:
	       asm pop bx
	       asm pop bp


           asm mov ax,0A000h
           asm mov es,ax
           asm mov ax, [color]
           asm mov es:[bx],ax
            return;
        }
        if (( h40.biBitCount == 8) ||
            ( h40.biBitCount == 16)||
            ( h40.biBitCount == 24))
        {
           if ( isVESA )
           {
               asm { push bp; mov ax,640; mov cx,y; mul cx
                   add ax,x
                   adc dx,0
                   mov bx,ax
                   and bx,word ptr [page_mask]
                   mov cx,word ptr [page_shift]
                   jcxz no_shift }
               sh:
               asm shl ax,1
               asm rcl dx,1
               asm loop sh
               no_shift:
               asm push bx
               asm cmp dx,last_page
	       asm je  mk_point
	       asm mov last_page,dx
	       asm mov ax,4F05h
	       asm xor bx,bx
	       asm int 10h
	   mk_point:
	       asm pop bx
	       asm pop bp
           }
           else
           {
               asm mov ax,maxX
               asm mov cx,y
               asm mul cx
               asm add ax,x
               asm mov bx,ax
           };

           asm mov ax,0A000h
           asm mov es,ax
           asm mov al,byte ptr [color]
           asm mov es:[bx],al
           return;
        }

        asm pusha;
        asm mov al,byte ptr [color];
        asm mov cx,[x];
        asm mov dx,[y];
        asm push    ax
        asm mov     ax,0A000h
        asm mov     es,ax
        asm mov     ax,dx
        asm mov     bx,80
        asm mul     bx
        asm mov     bx,ax
        asm mov     ax,cx
        asm mov     cx,8
	asm div     cx
        asm add     bx,ax
        asm mov     cx,dx
	asm mov     ax,8008h
        asm shr     ah,cl
        asm mov     dx, 3CEh
        asm out     dx,ax
        asm mov     al, es:[bx]
        asm pop     ax
        asm mov     es:[bx],al
        asm popa;
}

// 8 bpp, vesa
void pointXOR(int x, int y)
{
        if (( x>maxX ) || ( y>maxY )) return;

            asm { push bp; mov ax,640; mov cx,y; mul cx
                add ax,x
                adc dx,0
                mov bx,ax
                and bx,word ptr [page_mask]
                mov cx,word ptr [page_shift]
                jcxz no_shift }
            sh:
            asm shl ax,1
            asm rcl dx,1
            asm loop sh
            no_shift:
            asm push bx
            asm cmp dx,last_page
            asm je  mk_point
            asm mov last_page,dx
            asm mov ax,4F05h
            asm xor bx,bx
            asm int 10h
        mk_point:
            asm pop bx
            asm pop bp
        asm mov ax,0A000h
        asm mov es,ax
        asm not byte ptr es:[bx]
        return;
}

// --------------------------------- box drawing -----------------
struct
{
   int x,y,x1,y1;
} box;

//  ࠬ  ਬ 䥪
void mk_box( int *c)
{
   int i;
   if ( box.x>box.x1 )
   {
      i=box.x; box.x=box.x1; box.x1=i;
      *c = 1-(*c);
   }
   if ( box.y>box.y1 )
   {
      i=box.y; box.y=box.y1; box.y1=i;
      *c = 1-(*c);
   }

   for ( i=box.x; i<box.x1; i++ )
   {
      pointXOR( i, box.y );
      pointXOR( i, box.y1 );
   }
   for ( i=box.y; i<box.y1; i++ )
   {
      pointXOR( box.x, i );
      pointXOR( box.x1, i );
   }
}

int zzoom;

void apply(int mode)
{
   uchar *m;
   uchar *n;
   ulong offset;
   uint lin,wi;
   int hi,y,y1,i;
   uint c;
   if (( m=malloc( 64000U ) )==NULL ) return;

   box.x <<= zzoom;
   box.y <<= zzoom;
   box.x1 <<= zzoom;
   box.y1 <<= zzoom;

   wi=box.x1-box.x+1;
   hi=box.y1-box.y+1;
   lin=64000U / wi;   // ᥣ ப  
   offset=sizeof(scn_hdr)+(ulong)box.x+(ulong)box.y*(ulong)scn_hdr.x;
   while ( hi )
   {
      y=min( lin, hi );
      n=m;
      i=0;
      while ( y-- )
      {
         fseek( in, offset+(ulong)scn_hdr.x*(ulong)i, 0);
         fread( n, wi, 1, in);
         i++; n+=wi;
      }
      y=min( lin, hi );

      //---------------- 䨫 -------------------- filter
      if (mode==0)
      for ( i=0; (uint)i<y*wi; i++ )
      {
         c=m[i];
         c <<= 4; c /=12; if (c>255) c=255;
         m[i]=c;
      }

      if (mode==1)
      for ( i=0; (uint)i<(y-1)*wi; i++ )
      {
         c=m[i]+m[i+wi]+m[i+1]+m[i+wi+1];
         c >>= 2;
         m[i]=c;
      }

      if (mode==2)
      for ( i=0; (uint)i<(y-1)*wi;  )
      {
         c=m[i]-m[i+1]; if (c&0x8000) c= -c;
         if ( c<2 )
         {
            m[i]=m[i+1]; i+=2;
         }
         else i++;
      }

      hi -= y;
      n=m;
      i=0;
      y1=y;
      while ( y-- )
      {
         fseek( in, offset+(ulong)scn_hdr.x*(ulong)i, 0);
         fwrite( n, wi, 1, in);
         i++; n+=wi;
      }
      offset += (ulong)scn_hdr.x*(ulong)y1;
   }
   free(m);

   box.x >>= zzoom;
   box.y >>= zzoom;
   box.x1 >>= zzoom;
   box.y1 >>= zzoom;
}

void effects(void)
{
   int key;
   int delta, cur;
   box.x=10; box.y=10; box.x1=50; box.y1=50;
   delta=4;
   cur=1;   // 塞 㣮 ࠬ

   while ( 1 )
   {
       mk_box( &cur );
       key=bioskey(0);
       mk_box( &cur );
       switch ( key )
       {
	   case 0x1C0D: // Enter
                apply(0);
                return;
	   case 0x011B: // esc
		return;
           case 0x0F09: // tab
                cur = 1-cur;
                break;
           case 0x4E2B: // gray +
                if (delta<10) delta++;
                break;
           case 0x4A2D: // gray -
                if (delta>1) delta--;
                break;
	   case 0x3B00: // F1
                apply(1);
                return;
	   case 0x3C00: // F2
                apply(2);
                return;
	   case 0x3D00: // F3
	   case 0x3E00: // F4
           case 0x3F00: // F5
	   case 0x4000: // F6
	   case 0x4100: // F7
           case 0x4300: // F9
	   case 0x4400: // F10
	   case 0x4700: // Home
                break;
	   case 0x4800: // up
                if ( cur )
                { if (box.y1-delta >0) box.y1 -= delta; }
                else
                { if (box.y-delta >0) box.y -= delta; };
                break;
	   case 0x4B00: // left
                if ( cur )
                { if (box.x1-delta >0) box.x1 -= delta; }
                else
                { if (box.x-delta >0) box.x -= delta; };
                break;
	   case 0x4D00: // right
                if ( cur )
                { if (box.x1+delta <maxX) box.x1 += delta; }
                else
                { if (box.x+delta <maxX) box.x += delta; };
                break;
	   case 0x5000: // down
                if ( cur )
                { if (box.y1+delta <maxY) box.y1 += delta; }
                else
                { if (box.y+delta <maxY) box.y += delta; };
                break;
       }
   }
}

// ࠨ 楤 । 梥 窨
#pragma warn -sus
void set_proc(int bpp)
{
    switch (bpp)
    {
	case 1:
	    get_color=color1;
	    pointx=point1;
	    break;
	case 4:
	    get_color=color4;
	    pointx=point1;
	    break;
	case 8:
	    get_color=color8;
	    if ( isVESA ) pointx=point8vesa; else pointx=point8;
	    break;
        case 16:
            get_color=color8;   // !!!
	    if ( isVESA ) pointx=point8vesa; else pointx=point8;
	    break;
	case 24:
	    get_color=color24;
	    if ( isVESA ) pointx=point8vesa; else pointx=point8;
	    break;
	default:
	    pointx=point;
	    get_color=color4;
	break;
    }
    if ( EGA )
    {
       pointx=point1;
    }
}
#pragma warn +sus

long ftype=0; // ⨯ 䠩
#define isPCX  1
#define isSCN  2
#define isTGA  4
#define isRLE  8
#define isBMP 16
#define isGIF 32

char *extension[]= { ".PCX", ".SCN", ".TGA", ".RLE", ".BMP", ".GIF" };
void ChkName(char *argv[])
{
   int i;
   long mask=1;
   for ( i=0; i<6; i++, mask<<=1 )
   {
      if ( strstr(strupr(argv[1]), extension[i]) != NULL )
      {
         ftype |= mask; break;
      }
   }
   if (!ftype)
   {
      fprintf(stderr, "Input file has unknown extension.\n");
      exit(1);
   }
   if ((in = fopen(argv[1], (ftype == isSCN) ? "rb+" : "rb"))  == NULL)
   {
      fprintf(stderr, "Can`t open input file.\n"); exit(1);
   }
   strcpy( copyname, argv[1] );
   file_len = len = in_len = flen(in);
   switch ( ftype )
   {
        case isPCX:
             fread( &pcx_hdr, sizeof(pcx_hdr), 1, in );
             return;
        case isSCN:
             fread( &scn_hdr, sizeof( scn_hdr ), 1, in);
             if ( memcmp( scn_hdr.sign, "Scan1.0 ", 8 ))
             {
                fclose(in); printf("Not a valid .scn file\n"); exit(1);
             }
             if ( scn_hdr.x > 4096 )
             {
                fclose(in); printf("File is too wide (x>4096)\n"); exit(1);
             }
             return;
        case isTGA:
        case isRLE:
             fread( &TGA, 1, sizeof( TGA ), in ); // ⠥ 
             // 䫠 ᯮᮡ ࠭ ப ᢥ   ᭨ 
             if (( TGA.flags != 0x20) &&
                 ( TGA.flags != 0x08) &&
                 ( TGA.flags != 0x00)
                 )
             {
                fclose(in); printf("Unknown .tga flags\n"); exit(1);
             }
             return;
        case isBMP:
             fread( &bm_hdr, sizeof( bm_hdr ), 1, in);    // 1st part of bm_hdr
             if ((bm_hdr.bfType[0] != 'B') || (bm_hdr.bfType[1] != 'M'))
             { fprintf( out, "Not present 'BM' in header of %s\n", argv[1] );
               fclose(in);
               fclose(out);
               exit(1);
             }
             return;
        case isGIF:
             return;
   }
}





//------------------------ palette optimizing --------------------
#define CSUM(i) ((uint)palette[(i)]+(uint)palette[(i)]+(uint)palette[(i)])

int hi_indx, lo_indx;
//  ࠩ 梥⮢
void find_hilow(void)
{
   int i;
   hi_indx=lo_indx=0;
   for (i=0; i<256*3; i+=3)
   {
     if (CSUM(i)<CSUM(lo_indx)) lo_indx=i/3;
     if (CSUM(i)>CSUM(hi_indx)) hi_indx=i/3;
   }
}

//  ࠬ
void frame( int x, int y, int up)
{
    int i,j,c1,c2;
    c1= up ? hi_indx : lo_indx;
    c2= up ? lo_indx : hi_indx;

    for (i=0; i<16; i++)
    {
       point( x+i, y, c1 );
       point( x+i, y+10, c2 );
    }
    for (j=0; j<10; j++)
    {
       point( x, y+j, c1 );
       point( x+16, y+j, c2 );
    }
}

//  梥⭮ ⨪
void cbox( int x, int y, int color )
{
    int i,j;
    for (i=0; i<16; i++)
    for (j=0; j<10; j++)
       point( x+i, y+j, color );
}

// ⥭ 梥    
void get_rgb(RGBTRIPLE *c, int k)
{
   c->red   = palette[k+0];
   c->green = palette[k+1];
   c->blue  = palette[k+2];
};

//  梥    
void put_rgb(RGBTRIPLE *c, int k)
{
   palette[k+0] = c->red;
   palette[k+1] = c->green;
   palette[k+2] = c->blue;
};

void put_BM_palette( void);


// ᬮ   
void modify_palette(void)
{
    int i,j,k,n,n1,up,xx;
    long t;
    RGBTRIPLE colr, oclr, nclr, saveclr[32];

    xx=maxX-16*17;
    find_hilow();
    for (i=0; i<16; i++)
    for (j=0; j<16; j++)
    {
       cbox( xx+i*17, j*11, i+j*16 );
       frame( xx+i*17, j*11, 1 );
    }
    i=j=0;
    while ( 1 )
    {
       t= *(long *)MK_FP(0, 0x46C); up=0;
       frame( xx+i*17, j*11, 0 );
       k=(i+j*16)*3;
       get_rgb( &oclr, k );
       // ࠭ ࢠ 梥⮢
       for ( n=max(k-16*3,0), n1=0; n<min(k+15*3,255*3); n+=3, n1++ )
       {
          get_rgb( &saveclr[n1], n );
       }
       while (bioskey(1)==0) //  
       {
	  if ( t+10 < *(long *)MK_FP(0, 0x46C) )
	  {
	     t= *(long *)MK_FP(0, 0x46C);
	     up=1-up; frame( xx+i*17, j*11, up );
             //   shift
             if (bioskey(2)&0x3)
	     {
                if (bioskey(2)&0x8) //  ⮬ Alt 塞 ࢠ
                {
                   get_rgb( &nclr, up ? hi_indx*3 : lo_indx*3 );
                   for ( n=max(k-16*3,0); n<min(k+15*3,255*3); n+=3 )
                   {
                      put_rgb( &nclr, n );
                   }
                }
                else
                {
                   get_rgb( &nclr, up ? hi_indx*3 : lo_indx*3 );
                   put_rgb( &nclr, k );
                }
                SetPalette();
	     };
	  };
       };
       // ⠭ ࢠ 梥⮢
       for ( n=max(k-16*3,0), n1=0; n<min(k+15*3,255*3); n+=3, n1++ )
       {
          put_rgb( &saveclr[n1], n );
       }
       put_rgb( &oclr, k ); SetPalette();
       frame( xx+i*17, j*11, 1 );
       key=bioskey(0);
       switch ( key )
       {
	   case 0x011B: // esc
		return;
	   case 0x1400: // alt-T
	   case 0x1C0D: // Enter
	   case 0x1F13: // Ctrl+S
	   case 0x2000: // alt-D
	   case 0x2D00: // Alt+X
	   case 0x2F00: // alt-V
	   case 0x310E: // Ctrl+N
	   case 0x3B00: // F1
	   case 0x3C00: // F2
	   case 0x3D00: // F3
	   case 0x3E00: // F4
	   case 0x3F00: // F5 copy
	   case 0x4000: // F6
	   case 0x4100: // F7
	   case 0x4300: // F9 file lookup
	   case 0x4400: // F10
	   case 0x4700: // Home
		i=j=0; break;
	   case 0x4800: // up
		if ( j ) j--; else j=15; break;
	   case 0x4900: // PGup
	   case 0x4B00: // left
		if ( i ) i--; else i=15; break;
	   case 0x4D00: // right
		if ( i<15 ) i++; else i=0; break;
	   case 0x4F00: // End
	   case 0x5000: // down
		if ( j<15 ) j++; else j=0; break;
           case 0x2267: // 'g' get color
		k=(i+j*16)*3;
                get_rgb( &colr, k );
		break;
           case 0x1970: // 'p' put color
		k=(i+j*16)*3;
                put_rgb( &colr, k );
		SetPalette();
		break;
           case 0x1F73: // 's' save palette
		put_BM_palette();
		break;
	   case 0x5100: // PGdown
	   case 0x5500: // Shift+F2
	   case 0x5800: // Shift+F5 append
	   case 0x5900: // Shift+F6   ਭ
	   case 0x5A00: // Shft-F7
	   case 0x6900: // Alt+F2
	   case 0x6A00: // Alt+F3
	   case 0x6E00: // Alt+F7
	   case 0x6F00: // Alt+F8
	   case 0x7500: // Ctrl_End
	   case 0x7600: // Ctrl_PgDn
	   case 0x7700: // Ctrl_Home
	   case 0x8400: // Ctrl_PgUp
	   ;
       }
    }
}



char list=0;            // 뢠 ଠ  ଠ ࠦ

long old_image_size=0;
long pal_offset=0;
int  pal_count=0;
int  pal_mode=0;
// ⠥   䠩
void get_BM_palette( int count, int mode )
{
    int i;
    union
    {
       RGBQUAD rgb4;
       RGBTRIPLE rgb3;
    } x;
    pal_offset=ftell(in);
    pal_count=count;
    pal_mode=mode;
    i=0;
    while (count-- > 0)
    {
        fread( &x.rgb4, (mode==4) ? sizeof( RGBQUAD ) : sizeof( RGBTRIPLE),
               1, in);
        palette[i*3+0]= x.rgb4.red >> 2;
        palette[i*3+1]= x.rgb4.green >> 2;
        palette[i*3+2]= x.rgb4.blue >> 2;
        i++;
        if (list != 0) fprintf( out, "%02x %02x %02x \n",
        x.rgb4.red, x.rgb4.green, x.rgb4.blue);
    }
}

// 뢠  
void put_BM_palette( void)
{
    int i,count;
    union
    {
       RGBQUAD rgb4;
       RGBTRIPLE rgb3;
    } x;

    if ((old_image_size==0)||
	(pal_offset==0) ||
	(pal_count==0) ||
	(pal_mode==0)) return;

    fclose(in);
    if (( in=fopen(copyname,"rb+"))==NULL )
    {
       printf("\nCan't reopen image for palette writing\n");
       bioskey(0);
       exit(1);
    }
    fseek(in, pal_offset, 0);
    count=pal_count;
    i=0;
    while (count-- > 0)
    {
	get_rgb( &x.rgb3, i*3 ); x.rgb4.reserved=0;
	x.rgb4.red <<= 2;
	x.rgb4.green <<= 2;
	x.rgb4.blue <<= 2;

	fwrite( &x.rgb4, (pal_mode==4) ? sizeof( RGBQUAD ) : sizeof( RGBTRIPLE),
	       1, in);
	i++;
    }
    fseek(in, old_image_size, 0);
    fclose(in);
    if (( in=fopen(copyname,"rb"))==NULL )
    {
       printf("\nCan't reopen image after palette writing\n");
       bioskey(0);
       exit(1);
    }
}


void set_vmode_and_pal(int bpp)
{
        /*-----------------08.01.99 16:31-------------------
         BMP 24 bit per pixel
        --------------------------------------------------*/
        if (( bpp == 24) && ( vesa_modes > 3 )) // 16 bit
        {
           vesamode(0x111);          // 640x480 16 bit
           get_color=color24_16;
           pointx=point24;
           return;
        }
        if (( bpp == 24) && ( vesa_modes > 1 )) // 15 bit
        {
           vesamode(0x110);           // 640x480 15 bit
           get_color=color24_15;
           pointx=point24;
           return;
        }

        /*-----------------08.01.99 16:31-------------------
         DIB (bmp) 16 bit per pixel
        --------------------------------------------------*/
        if (( bpp == 16) && ( vesa_modes > 3 )) // 16 bit
        {
           vesamode(0x111);          // 640x480 16 bit
           get_color=color16_16;
           pointx=point24;
           return;
        }
        if (( bpp == 16) && ( vesa_modes > 1 )) // 15 bit
        {
           vesamode(0x110);           // 640x480 15 bit
           get_color=color16_15;
           pointx=point24;
           return;
        }

        //--------------------------------------------- EGA
        if (EGA) { vgamode( 0x12);
        asm { mov     dx, 3CEh
              mov     ax, 0205h
              out     dx, ax };  // ०  2
              maxX=640; maxY=480;
              return;
        }

        if (( bpp == 8) || ( bpp == 24))
	{
           isVESA ? vesamode(0x101) : vgamode(0x13); // 640x480 256
           if ( bpp == 8) SetPalette();
           else                         SetUniPalette();
           if (!isVESA) { maxX=320; maxY=200;}
           return;
	}
        vgamode(0x12);
        asm { mov     dx, 3CEh
              mov     ax, 0205h
              out     dx, ax };  // ०  2
	Set16Palette();
}

void SetGrayPalette(void)
{
    int i;
    for ( i=0; i<256; i++ )
    {
        palette[i*3+0]= i>>2;
	palette[i*3+1]= i>>2;
	palette[i*3+2]= i>>2;
    }
}

int explore=0;
void main2( void );
void main_gif( char *argv );

extern int split, // ࠧ ஢ GIF  ⤥ ࠦ
    clean, // १ ਨ  
    debug; // ᮮ饭   ࠣ GIF
extern uchar gmask; // ᪠  ࠧ冷  GIF

int clean_mask=0; // ᪠  
void main(int argc, char *argv[])
{
    int x=0;
    int	mul=0;
    int tdelay=0;
    int no_blank;
    struct dfree Free;
    long otime;
    long avail;
    int drive;
    char *optn;

    int ch;

	if (argc < 2) {
	printf(
	"\n\nVpix v1.1 (c) 1995-99  .. image viewer\n"\
	"맮: Vpix Infile [/Options]\n\n"\
	"P: /Lfilename - p p  p\n"\
	"\t\t 䠩 filename\n"\
	"\t/Fxx - ᮧ 䠩 .BMP (⮫쪮  True Color)\n"\
	"\t\t 㫥묨 訬 xx ⠬\n"\
	"\t\t   梥\n"\
	"\t/Mxx - ᮧ p, 饥  xx\n"\
	"\t\tp 室 p\n"\
	"\t/Tnnn - 뢠  祭 nnn ᥪ㭤\n"\
        "\t/TSnnn -  ,  ⪨ ࠭\npress any key...\n" );
        bioskey(0);
	printf(
	"\t/d to dither Hi-Color image downto 640x480x256\n"\
	"\t/e to use only EGA palette to dither Hi-Color image\n"\
	"\t/x explore image parameters\n"\
	"\t/v to disable VESA and use 320x200x256\n"\
	"\t/s to force slow but finest palette calculations\n\n"\
	"\t/b enable deBug messages\n"\
	"\t/o cut Off non-image .GIF extensions\n" \
        "\t/onn same as /o plus clear (zero) the nn least bits of palette\n" \
	"\t/p sPlit .GIF file into separate images\n\n",
	"Infile - 䠩 BMP (Windows Bitmap 1, 4, 8, 24 bit per pixel)\n"\
	" PCX (Paint Brush 320x200, 256 color)\n"\
	" 㬮砭 p 뢮  p\n"\
	" ० 640x480 16bit, 640x480 15bit, 640x480x256\n"\
	" 320x200x256 (஢  浪 ᫥)\n");

	exit(1);
	}

	if ( argc>2 && argv[2][0]=='/' )
	{
	   if ( strchr(argv[2], 's') ) quick=0;
	   if ( strchr(argv[2], 'd') ) dither=1;
	   if ( strchr(argv[2], 'e') ) EGA=1;
	   if ( strchr(argv[2], 'x') ) explore=1;
	   if ( strchr(argv[2], 'v') ) goto no_vesa;
	   if ( strchr(argv[2], 'p') ) split=1;
	   if ( strchr(argv[2], 'b') ) debug=1;
           if ( strchr(argv[2], 'o') )
           {
              split=1; clean=1;
              // ᫨ ࠭ /o3  ᪠ 㤥 (0xFF << 3)
              if (*( strchr(argv[2], 'o')+1 ))
              {
		 int i=atoi( strchr(argv[2], 'o')+1 );
                 while ( i-- ) gmask <<= 1;
	      }
	   }
	}

	if ( !get_vesa_info() ) goto no_vesa;
	{
	   if (( query_vesa_mode(0x101) +
		query_vesa_mode(0x110) +
		query_vesa_mode(0x111)
	    )==0) goto no_vesa;
	}

   if (debug) printf( "VESA detected, use 640x480, granul %u\n", granul );
   while (( granul & 0x40 ) == 0 )
   {
      granul <<= 1; // 饬  㫥 
      page_mask >>= 1;
      page_shift++;
   }
   isVESA=1;
   maxX=640;
   maxY=480;

   no_vesa:
    ChkName(argv);

    x=0;
    no_blank=0;
    if ((argv[2][0] == 0x2F) && (argv[2][1] == 0x54)) // '/T'
    {
    if ( argv[2][2] == 0x53 ) { x++; no_blank=1; }
    while ( isdigit(argv[2][x+2]))
        { tdelay *= 10;
          tdelay += (int)(argv[2][x+2]-48);
	  x++;
	}
        if ( !tdelay ) tdelay=1;
    }
    else tdelay=-1;

    if ( ftype==isPCX ) goto pcx256;
    if ( ftype==isTGA || ftype==isRLE ) { main2(); return; }
    if ( ftype==isGIF ) { main_gif( argv[1] ); return; }
    if ( ftype==isSCN )
    {
       int vert,zoom,ky;
       uchar static svid[4096];
       h40.biBitCount = 8;
       SetGrayPalette();
       set_proc(8);
       set_vmode_and_pal(8);
       len=ftell(in);
       zoom=0;
    zoomed:
       vert=0;
       ky = scn_hdr.y;
       while ((( ky--) >> zoom) > 0)
       {
	   fread( svid, scn_hdr.x, 1, in);
	   cur=svid;
	   bc = 1;
	   for ( i=0; i< scn_hdr.x; i++)
	   {
	      pointx( i>>zoom, vert>>zoom, get_color());
	   };
	   vert++;
       };
	   key=bioskey(0);
        if (key==0x1970)  // 'p' palette
        {
           modify_palette(); fseek( in, len, 0); goto zoomed;
        }
        if (key==0x1265)  // 'e' effects
        {
           zzoom=zoom;
           effects(); fseek( in, len, 0); goto zoomed;
        }
	if (key==0x2C7A)  // 'z' zoom
	{
	   zoom = (++zoom)&3; fseek( in, len, 0); goto zoomed;
	}
        vgamode(3); fclose(in); exit(1);
    }
    old_image_size=len;

    x=0;
    if ((argv[2][0] == 0x2F) && (argv[2][1] == 0x4D)) // '/M'
    while ( isdigit(argv[2][x+2]))
	{ mul *= 10;
	  mul += (int)(argv[2][x+2]-48);
	  x++;
	}



    //  १  ⮢
    if ((argv[2][0] == 0x2F) && (argv[2][1] == 'F')) // '/F'
    {
        clean_mask=atoi( &(argv[2][2]) );
        if ( h40.biBitCount != 24 )
        {
            printf("Not a TrueColor image !");
            exit(1);
        }
        argv[1][strlen(argv[1])-1]=0; // ० 㪢 'p'  .BMP
	if   ((out = fopen(argv[1], "wb")) == NULL)  out = stdout;
        fwrite( &bm_hdr, sizeof(bm_hdr), 1, out);
        avail = sizeof(bm_hdr);
        // 㥬   ࠦ
        while ( avail< bm_hdr.bfOffBits )
        {
	    fputc( fgetc( in ), out); avail++;
	}
	while ( avail< len )
	{
	    fputc((fgetc( in ) & (~clean_mask)), out); avail++;
	    if ((avail & 0xFF) == 1)
	    printf("\r%ld", avail );
	}
	   fclose(in);
	   if (out != stdout) fclose(out);
	   exit(0);
    };


   optn = argv[2];
   if ((argv[2][0] == 0x2F) && (argv[2][1] == 0x4C)) // '/L'
   { optn += 2;
   if   ((out = fopen(optn, "wt")) == NULL)  out = stdout;
   list = 1;
   }

    i=0;
    if (bm_hdr.biSize == 40) // । ⢮ 梥⮢
    {
	fread( &h40, sizeof( h40 ), 1, in);
	count=h40.biClrUsed;
        if (( h40.biClrUsed == 0 ) && (h40.biBitCount < 16 /* 24 */ ))
	count=( 1 << h40.biBitCount );
	get_BM_palette( count, 4 ); // ⠥ 
    } else

    if (bm_hdr.biSize == 12) // । ⢮ 梥⮢
    {
	count=0;
	fread( &h12, sizeof( h12 ), 1, in);
	h40.biWidth   = h12.biWidth;
	h40.biHeight  = h12.biHeight;
	h40.biPlanes  = h12.biPlanes;
	h40.biBitCount= h12.biBitCount;
        if (h40.biBitCount < 16 /* 24 */ ) count=( 1 << h40.biBitCount );
	get_BM_palette( count, 3 ); // ⠥ 
    } else
    {
      printf("BMP file header size is not 40 or 12 bytes\n" );
      fclose(in);
      exit(1);
    }

    set_proc( h40.biBitCount );

   if (mul > 0 ) {
        // p ᢮   ᪥
        drive = getdisk();
        getdfree(drive+1, &Free);
        if (Free.df_sclus == 0xFFFF)
	{
           printf("Error in getdfree() call\n");
           exit(1);
        }

        avail =  (long) Free.df_avail *
                 (long) Free.df_bsec *
                 (long) Free.df_sclus;
        if (avail <= mul*(bm_hdr.bfSize - bm_hdr.bfOffBits))
                { printf("\n\  p室  ﬨ\n\
        襣 ᪠, p⭮ 㬥襭  1\n");
                  mul = 1;
                }
    }

if (list != 0)
{
fprintf( out," 䠩         %s\n", argv[1] );
fprintf( out,"p 䠩   %c%c\n", bm_hdr.bfType[0], bm_hdr.bfType[1] );
fprintf( out," 䠩 (DOS) %ld.\n", bm_hdr.bfSize );
fprintf( out,"Pp            %d, %d\n", bm_hdr.bfReserved1,
                                           bm_hdr.bfReserved2 );
fprintf( out,"P. p   %ld.\n", bm_hdr.bfOffBits );

fprintf( out,"p p⨭   %ld.\n", h40.biWidth );
fprintf( out," p⨭   %ld.\n", h40.biHeight );
fprintf( out,"⮢    %d.\n",  h40.biPlanes );
fprintf( out,"               %d.\n",  h40.biBitCount );
}


    fseek( in, bm_hdr.bfOffBits, 0);
    set_vmode_and_pal(h40.biBitCount);
    if ((vid=malloc(( h40.biWidth + 16)*3)) != NULL)
    {
	int id;
	int vert=h40.biHeight;
	int hor=(h40.biWidth) * (h40.biBitCount);
      if ( hor & 0x1F ) hor += 0x1F;
      hor &= 0xFFE0;
      hor >>= 3;

    switch ( h40.biCompression )
    {
        case bi_RLE8:
            hor=0;
            while ( len>0 )
            {
                ch=fgetc(in); len--; if (ch==EOF) break;
                if ( !ch ) // ESCAPE char
                {
                    ch=fgetc(in); len--; if (ch==EOF) break;
                    if ( ch==0 ) { vert--; hor=0; continue; } // EOLN
                    if ( ch==1 ) { break; }            // EOBMP
                    if ( ch==2 )                       // DELTA
		    {
		       fgetc(in); fgetc(in);
		       // hor += fgetc(in); vert -= fgetc(in); len-=2;
                    }
                    else
                    {
                       while ( ch-- )
                       { pointx( hor++, vert, fgetc(in)); len--; }
                       if ( ftell(in) & 1 ) { fgetc(in); len--; }
                    }
                }
                else
                {
                    id=fgetc(in); len--; if (id==EOF) break;
                    while ( ch-- ) pointx( hor++, vert, id);
                }
            }
            break;
        case bi_RLE4:
            break;
        default:
            goto no_compressed;
    }
    goto done;

    no_compressed:
    while ((long)len < ((long)hor * ((long)vert)+ bm_hdr.bfOffBits)) hor--;

        while (vert > 0)
        {
            int c;
            fread( vid, hor, 1, in);
            cur=vid;
            bc = 1;
            if (vert<maxY)
	    for ( c=0; c< h40.biWidth; c++)
            {
               pointx( c, vert, get_color());
            };
            vert--;
        };

        done:
        free(vid);
    };
    if ( tdelay==-1 ) key=bioskey(0);
    else
    {
       otime = *(long *)MK_FP( 0, 0x46C );
       otime += tdelay*18;
       while (((key=bioskey(1))==0) &&
               (otime>= *(long *)MK_FP( 0, 0x46C )));
       if (bioskey(1)) bioskey(0);
    };
    if (key==0x1970) modify_palette();
    if ( !no_blank ) vgamode(3);

if (mul > 0)
{
    argv[1][strlen(argv[1])-5] = 33;	//  室  
					// 䠩  p p⨭

   if	((bmpOut = fopen(argv[1], "wb")) == NULL)
   {
      fprintf(stderr, "\nFopen() failure \n");
      fclose(in); fclose(out); exit(1);
   }

   {
	long int 	oldImageSize, count;
	unsigned int    n;

   if   ((buffer = malloc( 32*1024L )) == NULL)
   {
      fprintf(stderr, "\nMalloc() failure \n");
      fclose(in); fclose(out); exit(1);
   };

        oldImageSize =  bm_hdr.bfSize - bm_hdr.bfOffBits;
	h40.biHeight *= mul; //  쪨 p⨭  
        bm_hdr.bfSize = bm_hdr.bfOffBits + ((long)mul)*oldImageSize;

        fwrite( &bm_hdr, sizeof(bm_hdr), 1, bmpOut);

   fseek( in, (long)sizeof(bm_hdr), 0); //  砫 室 䠩,
					// ᫥  

   count = bm_hdr.bfOffBits - (long)sizeof(bm_hdr);

   while ( count-- > 0 )	fputc( fgetc(in),bmpOut );
	// p㥬 ⮪ 


   for ( x = 0; x < mul ; x++)
   { fseek( in, bm_hdr.bfOffBits, 0);
	count = oldImageSize;
	while ( count > 0 ) {
		n = (unsigned int)((count > 32*1024L ) ? 32*1024L : count);
		fread((char far *)buffer, 1, n, in);
		fwrite((char far *)buffer, 1, n, bmpOut);
		count -= n;
	}

   };
   free(buffer);
   };
   fclose(bmpOut);
}
   fclose(in);
   if (out != stdout) fclose(out);
   exit(0);

pcx256:

    pict=ftell( in );

    fseek(in, file_len-769L, 0);
    c=fgetc(in);
    fread( &palette, sizeof(palette), 1, in );
    if (c==12) for( i=0; i<3*256; i++) palette[i] = (palette[i] >> 2);

   optn = argv[2];
   if ((argv[2][0] == 0x2F) && (argv[2][1] == 0x4C)) // '/L'
   { optn += 2;
   if   ((out = fopen(optn, "wt")) == NULL)  out = stdout;
   list = 1;
   }

   if ( list )
   {
     printf("Manuf=%02X, hard=%02X, encod=%02X, bitpx=%02X\n",
     (uint)pcx_hdr.manuf, (uint)pcx_hdr.hard, (uint)pcx_hdr.encod, (uint)pcx_hdr.bitpx );
     printf("x1=%4u, y1=%4u, x2=%4u, y2=%4u\n", pcx_hdr.x1, pcx_hdr.y1, pcx_hdr.x2, pcx_hdr.y2);
     printf("hres=%4u, vres=%4u\n", pcx_hdr.hres, pcx_hdr.vres);
     printf("vmode=%02X, nplanes=%02X\n", (uint)pcx_hdr.vmode, (uint)pcx_hdr.nplanes);
     printf("bplin=%4u, palinfo=%4u\n",  pcx_hdr.bplin, pcx_hdr.palinfo);
     printf("shres=%4u, svres=%4u\n",  pcx_hdr.shres, pcx_hdr.svres);
     getch();
   }


    fseek(in, pict, 0);
    if ((get = malloc(pcx_hdr.bplin)) == NULL)
    { printf("Malloc()\n"); exit(1); };
    if ((put = malloc((pcx_hdr.x2-pcx_hdr.x1)*2)) == NULL)
    { printf("Malloc()\n"); exit(1); };
    to = put;
    j = fread( get, 1, pcx_hdr.bplin,  in );
    from = get;
    count = 0;


   asm mov ax,0F00h
   asm int 10h
   asm cmp al,13h
   asm je set_vm

   vgamode(0x13);
set_vm:

   maxX=320; maxY=200;
   SetPalette();

   if ( pcx_hdr.y2 > maxY )
   {
      pcx_hdr.y2 = maxY;
   }

    for ( y=0; y < pcx_hdr.y2; y++ )
    {
        for ( i=0; i<pcx_hdr.bplin; i += count )
        {
                if ( j == 0 )
                {
                    j = fread( get, 1, pcx_hdr.bplin, in );
		    from = get;
		}
		c= *from++; j--;
		if (( c & 0xC0 )== 0xC0 )
		{
		count = c & 0x3F;
		if ( j == 0 )
		{
                    j = fread( get, 1, pcx_hdr.bplin, in );
                    from = get;
                }
                c= *from++; j--;
                }
                else count=1;
                for ( x=0; x<count; x++ )  put[i+x]= c;
        }
	asm { push ax; push cx; push dx; push si; push di; push ds; push es
	mov ax,word ptr [y]
	lds si,dword ptr [to]
	mov di,320
	mul di
	mov	di,ax
        mov cx,320/2
	mov ax,0A000h
	mov es,ax
        rep movsw
	pop es; pop ds; pop di; pop si; pop dx; pop cx; pop ax }
    }
    if ( tdelay==-1 ) key=bioskey(0);
    else
    {
       otime = *(long *)MK_FP( 0, 0x46C );
       otime += tdelay*18;
       while (((key=bioskey(1))==0) &&
               (otime>= *(long *)MK_FP( 0, 0x46C )));
       if (bioskey(1)) bioskey(0);
    };
    if ( !no_blank ) vgamode(3);
    fclose(in);
    free(get); free(put);
    exit(0);
}


//---------------------- ⨬  ---------------------
   // ᫮     梥
   #define CBITS 4
   #define BIGpaletteSize (1<<(CBITS*3))
   // 梥⮢   梥⮢ 让 ⠡
   uchar BIGpalette[BIGpaletteSize*3];
   // ⠡ ஢ 梥⮢,  뢮  ࠭ ᮤন  䨧᪨
   // 梥⮢ 0..255, ᮮ⢥ ᪨ 梥⠬ 0..4095
   // 梥,    ࠦ,   -1
   uint palette_index[BIGpaletteSize]; // 12-  梥⮢

//  ᪮쪮 ᤢ ࠢ  梥, ⮡  ID 梥
#define ClrID_bit 4

   uint i,j, aClr, d;

   uint delta1, delta2, delta3,
         min_delta; // ﭨ  梥⠬  梥⮢ 㡥
   uint clr, best_clr1, best_clr2; // ⥪騩  梥  訩 梥
   uint id; //  梥


   char bit_per_color=0; // ᫮     梥
   char alfa_ch=0;

   ulong pal_size=0; // ࠧ   䠩




char RLE=0; // ਧ ᦠ⮣ ࠦ
uchar pcnt=0; // 稪 ᥫ
uint value;    // 祭 梥

// ᤢ  䠩  砫 ⨭
void go2image( void )
{
   fseek( in, sizeof( TGA )+ TGA.skip + pal_size, 0);
}

// 室     梥
uint Hcolor( uchar r, uchar g, uchar b )
{
	if ( r>g )
        {
           return ( r>=b ) ? 1 : 3;
        }
        else
           if ( g>=b ) return 2; else return 3;
}

uchar color_8;
void GetRGB(void)
{
    switch ( bit_per_color )
    {
        case 5:
        fread( &value, 1, sizeof( value ), in ); return;
        case 8:
        if ( alfa_ch )
         // RGB 24-bit & alfa channel
        fread( &p.RGBAvalue, 1, sizeof( p.RGBAvalue ), in );
        else fread( &p.RGBvalue, 1, sizeof( p.RGBvalue ), in );
        return;
        case 2:
        color_8=fgetc( in ); return;
    }
}

uchar repeat=0; //  ࠭-७  ࠧ
//  । ᥫ ( ⥭  䠩,  RLE ᯠ)
void get_pixel(void)
{
    if ( RLE )
    {
            if ( pcnt==0 )
            {
               fread( &pcnt, 1, sizeof( pcnt ), in );
               repeat = (pcnt & 0x80);
               pcnt &= 0x7F; pcnt += 1;
               GetRGB();
            };
            rgb=value;
	    RGB.r=p.RGBvalue.r;
	    RGB.g=p.RGBvalue.g;
	    RGB.b=p.RGBvalue.b;
            if ( repeat ) { pcnt--; return; }
            else { if (--pcnt != 0) GetRGB(); return; };
    }
    else // not compressed
    {
       GetRGB();
       rgb=value;
       RGB.r=p.RGBvalue.r;
       RGB.g=p.RGBvalue.g;
       RGB.b=p.RGBvalue.b;
    }
}

// 室  梥 室  8   ᥫ
void Color8(void)
{
   color= RGB.r >> ClrID_bit;
   aClr=RGB.g >> ClrID_bit;
   color += ( aClr << ClrID_bit);
   aClr=RGB.b >> ClrID_bit;
   color += ( aClr << (ClrID_bit*2));

   color=palette_index[color];
}

// 室  梥 室  5   ᥫ
void Color5(void)
{
   color= (rgb >> 1)&0x0F;
   aClr= (rgb >> 6)&0x0F;
   color += ( aClr << 4);
   aClr= (rgb >> 11)&0x0F;
   color += ( aClr << 8);

   color=palette_index[color];
}

// 室  梥 室  8   ᥫ
void Color8ditherEGA(void)
{
   color=8;
}

// 室  梥 室  8   ᥫ
void Color8dither(void)
{
   int  r,g,b,r1,g1,b1;
   //   祭
   //     
   x_red   = RGB.b>>2;           // 祬-  ⠬ R<->B
   x_green = RGB.g>>2;
   x_blue  = RGB.r>>2;
   // ⥬ 訡 ।饩 窨
   // ०   3   red, 3 green, 2 blue

   e_red += x_red;
   e_green += x_green;
   e_blue  += x_blue;

   if (e_red<0) e_red=0;
   if (e_green<0) e_green=0;
   if (e_blue<0) e_blue=0;

   r = (e_red) >>3;    r += (e_red & 4) > 0;
   g = (e_green) >>3;  g += (e_green & 4) > 0;
   b = (e_blue) >>4;   b += (e_blue & 8) > 0;

   r1=0; g1=0; b1=0;
   if (r>7) { r=7; r1=1; }
   if (g>7) { g=7; g1=1; }
   if (b>3) { b=3; b1=1; }

   color=b+g*4+r*32;
   e_red   -= ((r1) ? e_red : palette[color*3+0]);
   e_green -= ((g1) ? e_green : palette[color*3+1]);
   e_blue  -= ((b1) ? e_blue :palette[color*3+2]);

}


// 室  梥 室  5   ᥫ
void Color5dither(void)
{
   int  r,g,b,r1,g1,b1;
   //   祭 ( 冷 梥⮢  ᫮ BGR )
   //     
   x_red   = ((rgb >> 10) & 0x01F)<<1;
   x_green = ((rgb >> 5) & 0x01F)<<1;
   x_blue  = (rgb & 0x01F)<<1;
   // ⥬ 訡 ।饩 窨
   // ०   3   red, 3 green, 2 blue

   e_red += x_red;
   e_green += x_green;
   e_blue  += x_blue;

   if (e_red<0) e_red=0;
   if (e_green<0) e_green=0;
   if (e_blue<0) e_blue=0;

   r = (e_red) >>3;    r += (e_red & 4) > 0;
   g = (e_green) >>3;  g += (e_green & 4) > 0;
   b = (e_blue) >>4;   b += (e_blue & 8) > 0;

   r1=0; g1=0; b1=0;
   if (r>7) { r=7; r1=1; }
   if (g>7) { g=7; g1=1; }
   if (b>3) { b=3; b1=1; }

   color=b+g*4+r*32;
   e_red   -= ((r1) ? e_red : palette[color*3+0]);
   e_green -= ((g1) ? e_green : palette[color*3+1]);
   e_blue  -= ((b1) ? e_blue :palette[color*3+2]);

}


// 室  梥 室  2   ᥫ
void Color2(void)
{
   color=color_8;
}

// 室  梥 室  1   ᥫ
void Color1(void)
{
   // 稬 ⨭ 梥
   color=palette_index[color];
}



void (*pointx)(int x, int y, int color); // 㪠⥫  㭪 ᮢ.窨
// ࠨ 楤 । 梥 窨
void set_proc2(void)
{
    switch (bit_per_color)
    {
        case 8:
            if (dither)
               get_color= (EGA) ? Color8ditherEGA : Color8dither;
            else get_color=Color8;
	    break;
        case 5:
            if (dither)
               get_color= (EGA) ? Color5ditherEGA : Color5dither;
            else get_color=Color5;
	    break;
        case 2:
            get_color=Color2;
            break;
        default:
            get_color=Color1;
            break;
    }
    if ( isVESA ) pointx=point8vesa; else pointx=point8;
    if ( EGA )
    {
       pointx=point1;
    }
}

void ShowLine(void)
{
	i=0;
        while ( i<TGA.xsize )
        {
            get_pixel();
            if ( i<maxX && j<maxY )
            {
              // ᫨  梥  襭 祭
              get_color();
              // ⠢ 
	      pointx( i, j, color);
            };
            i++;
        };
}


// । 梥  窨  RGB ଠ
void calc_24bit( void )
{
    get_pixel();
    // ᫨  梥  襭 12- 祭
    color= RGB.r >> ClrID_bit;
    aClr=RGB.g >> ClrID_bit;
    color += ( aClr << ClrID_bit);
    aClr=RGB.b >> ClrID_bit;
    color += ( aClr << (ClrID_bit*2));
    // VGA  6   , ࠭ 梥
    aClr=color*3;
    BIGpalette[aClr+0]=RGB.b >> 2;
    BIGpalette[aClr+1]=RGB.g >> 2;
    BIGpalette[aClr+2]=RGB.r >> 2;
}

// । 梥  窨  15-⮢ ଠ
void calc_15bit( void )
{
    get_pixel();
    // ᫨  梥  襭 12- 祭
    color= (rgb >> 1)&0x0F;
    aClr= (rgb >> 6)&0x0F;
    color += ( aClr << 4);
    aClr= (rgb >> 11)&0x0F;
    color += ( aClr << 8);
    // VGA  6   , ࠭ 梥
    aClr=color*3;
    BIGpalette[aClr+0]= (rgb >> 9)&0x03E;
    BIGpalette[aClr+1]= (rgb >> 4)&0x03E;
    BIGpalette[aClr+2]= (rgb << 1)&0x03E;
}

// । ﭨ  梥⠬  ࠭⢥ RGB
uint distance( uint i, uint j )
{
// ண , delta=sqrt( d1+d2+d3 );
//  d1..d3  ࠧ⥩  梥⮢ 
//  ᪮  ⮫쪮 ᮮ⭮襭 ࠧ⥩   梥⮢,
//   ᮫ 祭 ࠧ⥩,
//  ७     祭 ,
// । 梥⮢ ⠭  㬬 ⠭権 
     asm  mov     di,word ptr [i]
     asm  mov     si,word ptr [j]
     asm  mov     ax,di
     asm  shl     di,1
     asm  add     di,ax
     asm  mov     ax,si
     asm  shl     si,1
     asm  add     si,ax
     asm  add     si,offset BIGpalette
     asm  add     di,offset BIGpalette

     asm  mov     al,byte ptr [di]
     asm  sub     al,byte ptr [si]
     asm  jnc     m1
     asm  neg     al
m1:
     asm  mov     ah,0
     asm  mov     dx,ax

     asm  inc     si
     asm  inc     di
     asm  mov     al,byte ptr [di]
     asm  sub     al,byte ptr [si]
     asm  jnc     m2
     asm  neg     al
m2:
     asm  add     dx,ax

     asm  inc     si
     asm  inc     di
     asm  mov     al,byte ptr [di]
     asm  sub     al,byte ptr [si]
     asm  jnc     m3
     asm  neg     al
m3:
     asm  add     ax,dx
     asm  mov     word ptr delta1,ax
        return _AX;
}

uchar tmp_pal[9]; // ६   ⫠
void box13(uint x, uint y, uchar color)
{
   uint j;
   for ( j=0; j<20; j++ ) memset((void far *) MK_FP( 0xA000, 320*(y+j) + x), color, 20);
}

   uint total_color, non_fit, every, last_used;

// 뢠    梥
void show2box(void)
{
      best_clr1*=3;
      best_clr2*=3;
      tmp_pal[3]=BIGpalette[best_clr1+0];
      tmp_pal[4]=BIGpalette[best_clr1+1];
      tmp_pal[5]=BIGpalette[best_clr1+2];
      tmp_pal[6]=BIGpalette[best_clr2+0];
      tmp_pal[7]=BIGpalette[best_clr2+1];
      tmp_pal[8]=BIGpalette[best_clr2+2];
   asm push bp
   asm mov dx,offset [tmp_pal]
   asm push ds
   asm pop es
   asm mov ax,1012h
   asm mov cx,6  // 梥
   asm mov bx,0
   asm int 10h
   asm pop bp
       box13(0,0,1); box13(25,0,2);
}

uint level, color_stack[16]; // ६   梥⮢

void slow_palette(void)
{
   uchar found; int best, olink;

   best=4; // 訩   ⠭樨

   //  横 믮,    梥, 
   // ⨢訥  
   while ( non_fit )
   {
      // ᨬ ﭨ  梥⠬ RGB(0,0,0)  RGB(255,255,255)
      min_delta = 0x0FFF; found=0;
      // ।  梥⮢ 
      for ( i=0; i<BIGpaletteSize; i++)
      {
         //   ()  ࠦ,  ,
         //    뫪 㣮 梥
         if ( palette_index[i] & 0xB000 ) continue;

         //   ⠢ 梥⮢
         for ( j=0; j<BIGpaletteSize; j++ )
         {
            if ( palette_index[j] & 0xB000 ) continue;
            if ( i==j ) continue;
            // ᫨ 梥  , 祬 㣨
            if ( min_delta>distance(i,j))
            {
               //  
               best_clr1=i;
               best_clr2=j; min_delta = delta1; found=1;
               if ( delta1 < best ) goto a;
            }
         }
      }
      // ᫨   ᮫  ⠭樨,
      //   宦 ⠪   梥⮢ ⠭
      // 쭥訩  -  㦥  㤥
      if ( found )
      {
         best = min_delta+1;
      }
    a:
      if ( found )
      {
      //  ஥ 祭
      olink=palette_index[best_clr2];
      // ᮧ 뫪   䨧᪨ 梥 best_clr1
      palette_index[best_clr2]=best_clr1|0x8000; non_fit--;
   // ⮡  㤠 梥,    뫪, 
   // 㦭 
      palette_index[best_clr1] |= 0x4000;

              // ᫨  㤠塞 梥 ࠭ 뫠, 㦭 ࠢ
              //  뫪
              if ( olink & 0x4000 )
              {
                   for ( i=0; i<BIGpaletteSize; i++)
                   {
		       if ( palette_index[i]== (0x8000 | (olink & 0x0FFF) ))
                       {
                           palette_index[i]=best_clr1|0x8000;
                       }
                   }
              }

      }

      show2box();
      asm mov dx,10
      asm mov bx,0
      asm mov ah,2
      asm int 10h
      printf("%3d %3d", non_fit, best );

       asm mov ah,1
       asm int 16h
       asm cmp al,27
       asm jne mmm
       asm mov ah,0
       asm int 16h
       break;
       mmm:
       ;
   }

   // ᪮㥬   ४樥 ஢ 梥
   color=0; i=0;
   while ( i<BIGpaletteSize && color < 256)
   {
        // ᫨  梥,   뫪  ॣ஢ 梥
        if ((palette_index[i] & 0xB000)==0)
        {
                aClr=color*3;
		d=i*3;
                palette[aClr+0]=BIGpalette[d+0];
                palette[aClr+1]=BIGpalette[d+1];
                palette[aClr+2]=BIGpalette[d+2];
                palette_index[i++]=color++;
        }
        else i++;
   };
   // ࠢ 뫪  ᪫祭   梥
   for ( i=0; i<BIGpaletteSize; i++)
   {
        // ᫨ 뫪  梥
        if ((palette_index[i] & 0xF000)==0x8000)
        {
                palette_index[i] &= 0x0FFF;
                j= palette_index[i]; // 梥   뫪
                palette_index[i] = (palette_index[j] & 0x0FFF);
        }
        else
        if ((palette_index[i] & 0xF000)==0x4000)
             palette_index[i] &= 0x0FFF;
   }
}

void quick_palette(void)
{
   // ᪮쪮    256 VGA
   if ( total_color>256 ) non_fit=total_color-256; else non_fit=0;
   // ய᪠  every (2-, 7-  ..) 梥, ⮡ ࠢ୮
   // ⨫ () 
   every=4096;
   if ( non_fit )
   {
     every= (256-1)/non_fit+1;
     if ( every<2 ) every=2;
   }

   // ᪮㥬   ४樥 ஢ 梥
   color=0;
   last_used=0;  // ।騩 梥  몠   palette_index[]
   j=0;          // 浪  梥, ⮣  palette_index[]
   i=0;
   while ( i<BIGpaletteSize )
   {
        if (palette_index[i]!=0xFFFF)
        {
            if ( j % every ) // ᫨  梥  ᪫砥
            {
                aClr=color*3;
		d=i*3;
                palette[aClr+0]=BIGpalette[d+0];
                palette[aClr+1]=BIGpalette[d+1];
                palette[aClr+2]=BIGpalette[d+2];
                palette_index[i++]=color;
                last_used=color;
                if ( ++color == 256 ) break;
            }
            else
	    {
                aClr=last_used*3;
		d=i*3;
		if (
                     Hcolor( palette[aClr+0],
                             palette[aClr+1],
                             palette[aClr+2] ) ==
		     Hcolor( BIGpalette[d+0],
			     BIGpalette[d+1],
			     BIGpalette[d+2] )
                   )
                palette_index[i++]=last_used;
                else palette_index[i++]=color+1;
            };
            j++;
	}
        else i++;
   };
}

void main2( void )
{
   // ᫮ 梥⮢ bit per pixel
   switch ( TGA.bpp )
   {
        case 0x20:
          alfa_ch=1;
        case 0x18:
          bit_per_color=8; break;
        case 0x10:
        case 0x0F:
          bit_per_color=5; break;
        default:
          goto unknown;
   }

   if ( TGA.image_type == 0x0A ) { RLE=1; goto good; }
   else
   if ( TGA.image_type == 0x02 ) goto good;

   unknown:
   // last chance for paletted TARGA
   if (( TGA.colormap_type == 1 )&&
       (TGA.image_type == 1)&&
       ( TGA.bpp == 0x08 ))
   {
      if ( TGA.colormap_flags ==0x18 ) pal_size=256*3;
      if ( TGA.colormap_flags ==0x20 ) pal_size=256*4;
      bit_per_color=2; goto good;
   }
   if (( TGA.colormap_type ==0 ) &&
       ( TGA.colormap_flags == 0 ) &&
       (TGA.image_type == 3) &&
       ( TGA.bpp == 0x08 ))
   {
      pal_size=0; //  ⥭ 梥  
      bit_per_color=2; goto good;
   }
   printf( "Sorry, Unknown .TGA or .RLE file format:\n");
 exp:
   printf( "Skip=%u ColorMap type=%Xh Image type=%Xh\n",
           TGA.skip, TGA.colormap_type, TGA.image_type);
   printf( "ColorMap begin=%Xh length=%Xh flags=%Xh\n",
           TGA.colormap_begin, TGA.colormap_len, TGA.colormap_flags);
   printf( "X=%u Y=%u\n", TGA.xsize, TGA.ysize);
   printf( "Bit per pixel=%u flags=%Xh\n", TGA.bpp, TGA.flags);
   fclose(in);
   exit(1);

   good:
   if ( explore ) goto exp;

   set_proc2(); // ன ᮢ 楤
   //  砫 ᥫ
   if ( bit_per_color!=2 ) go2image();
   else
   {
       if ( pal_size==0 ) SetGrayPalette();
       else
       // ⠥ 
       for ( i=0; i<256; i++ )
       {
       fread( &p.RGBvalue, 1, sizeof( p.RGBvalue ), in );
       if (pal_size==256*4) fgetc(in);
	  // 塞 冷 BGR
	     palette[i*3+0]=p.RGBvalue.b >>2;
	     palette[i*3+1]=p.RGBvalue.g >>2;
	     palette[i*3+2]=p.RGBvalue.r >>2;
       };
       total_color=256;
       goto set_palette;
   }
   // ⨬ 
   for ( i=0; i<BIGpaletteSize*3; i++ ) BIGpalette[i]=0;
   // ⨬  梥
   for ( i=0; i<BIGpaletteSize; i++ ) palette_index[i]=0xFFFF;

   j=0;
   // ᮧ 
   printf( "Creating palette...\n");
   while ( j<TGA.ysize )
   {
        i=0;
        while ( i<TGA.xsize )
        {
            if ( bit_per_color==5 ) calc_15bit();
            if ( bit_per_color==8 ) calc_24bit();
            // ॣ㥬 12-⮢ 梥
            palette_index[color]=color;
            i++;
        };
        j++;
   };
   // ⠥ ⢮  梥⮢  
   total_color=0;
   for ( i=0; i<BIGpaletteSize; i++ )
   if (palette_index[i]!=0xFFFF) total_color++;

   // ᪮쪮    256 VGA
   if ( total_color>256 ) non_fit=total_color-256; else non_fit=0;
   // । ।  梥⮢ "让"  ⠪ ,
   // ﭨ  묨  ࠭⢥ RGB 쭮
   //     㣮


   asm mov      ax,13h
   asm int      10h

   if ( !dither )
   {
      if ( quick ) quick_palette(); else slow_palette();
   }

   set_palette:
   isVESA ? vesamode(0x101) : vgamode(0x13);
   if (dither)
   { (EGA) ? SetEGApalette() : SetUniPalette(); }
   else SetPalette();

   //  砫 ᥫ
   go2image();
   if ( TGA.flags == 0x20 )
   {
           j=0;
           while ( j<TGA.ysize )
           {
                ShowLine();
                j++;
           };
   }
   else if ((  TGA.flags == 0x00 ) ||
            (  TGA.flags == 0x08 ) ||
            (  *((uint *)&TGA.bpp) == 0x0010 ) ||
            (  *((uint *)&TGA.bpp) == 0x0008 ))
   {
           j=TGA.ysize;
           while ( j )
           {
                ShowLine();
                j--;
           };
   };

   fclose(in); fclose(out);
   bioskey(0);
   vgamode(3);
   printf( "%u colors used\n", total_color );
   exit(0);
}

